=== debian/changelog ===
flashrom (1.2-5) unstable; urgency=medium

  [ Mario Limonciello ]
  * debian/control:
    - Explicitly depend on libflashrom1 in libflashrom-dev
    - Drop ninja-build dependency (meson depends on it)
    - Drop dh-exec dependency (not needed)

  [ Pino Toscano ]
  * debian/control:
    - Remove extra libusb-dev dep (Closes: #951798)

 -- Mario Limonciello <mario.limonciello@dell.com>  Thu, 05 Mar 2020 07:50:28 -0600

flashrom (1.2-4) unstable; urgency=medium

  * debian/rules:
    - Don't build twice with meson and autotools
    - Remove unneeded comments
    - Only build configuration options that work on x86 on x86
      (Fix FTBFS on many architectures)
  * debian/*.install
    - Use wildcards to install all the files
  * Fix the pkgconfig location
  * Only install the headers that are needed
  * debian/control:
    - Add me to uploaders.
    - Set EFI team as new maintainer.
  * debian/libflashrom.install:
    - Fix installation of .so file to correct package
    - Remove dh-exec from header

 -- Mario Limonciello <mario.limonciello@dell.com>  Wed, 04 Mar 2020 20:06:53 -0600

flashrom (1.2-3) unstable; urgency=medium

  * Also install pkg-config file.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Fri, 21 Feb 2020 07:57:36 +0100

flashrom (1.2-2) unstable; urgency=medium

  * Build additional packages. (Closes: #951589)
  * d/control: drop CDBS.
  * Bump debhelper version to 11.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Wed, 19 Feb 2020 07:09:31 +0100

flashrom (1.2-1) unstable; urgency=medium

  * New upstream version. (Closes: #948192)
  * Bump standards version to 4.5.0.
  * Add Vcs fields.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Mon, 10 Feb 2020 07:05:32 +0100
